# solar.py
# Example for CS 1 Lab Assignment 2.
# db, thc; 2011-2016


from cs1lib import *
from system import System
from body import Body

# variables
orbit = False

year = 0

# constants
ORBIT = " "

WINDOW_WIDTH = 400
WINDOW_HEIGHT = 400

TIME_SCALE = 3e6         # real seconds per simulation second
PIXELS_PER_METER = 7 / 1e10  # distance scale for the simulation
FRAMERATE = 80              # frames per second
TIMESTEP = 1.0 / FRAMERATE  # time between drawing each frame

TITLE_SIZE = 40
INSTRUCTION_SIZE = 18


# planet = Body(mass, x, y, pos_adjustment, vx, vy, ):
sun = Body("sun.png", 1.98892e30, 0, 0, 30, 0, 0)
mercury = Body("mercury.png", 0.33e24, -57.9e9, 0, 3, 0, 47890)
venus = Body("venus.png", 4.87e24, -108.2e9, 0, 5, 0, 35040)
earth = Body("earth.png", 5.97e24, -149.6e9, 0, 6, 0, 29790)
mars = Body("mars.png", 0.642e24, -227.9e9, 0, 4, 0, 24140)

solar_system = System([sun, mercury, venus, earth, mars])


# Purpose: detect if the space key is pressed and signal the planets to orbit
# Parameters: (key) senses every key pressed
def keydown(key):
    global orbit, ORBIT

    if key == ORBIT:
        orbit = True


# Purpose: Show a title frame for the simulation
# Parameter: none
def title():
    # set background to black
    set_clear_color(0, 0, 0)
    clear()

    # draw bodies
    solar_system.draw(WINDOW_WIDTH / 2, WINDOW_HEIGHT / 2, PIXELS_PER_METER)

    # Draw title
    set_font_size(TITLE_SIZE)
    set_stroke_color(1, 0, 0)
    draw_text("The Solar System", 45, 50)

    # press space to begin
    set_font_size(INSTRUCTION_SIZE)
    set_stroke_color(1, 1, 1)
    draw_text("Press the space bar to see the planets orbit", 30, 380)


# Purpose: simulate planets in the solar system
# parameters: none
def main():
    if orbit:
        set_clear_color(0, 0, 0)    # black background
        clear()

        # Draw the system in its current state.
        solar_system.draw(WINDOW_WIDTH / 2, WINDOW_HEIGHT / 2, PIXELS_PER_METER)

        # Update the system for its next state.
        solar_system.update(TIMESTEP * TIME_SCALE)

    else:
        title()


start_graphics(main, 2400, framerate=FRAMERATE, key_press=keydown)